//+----------------------------------------------------------------------------+
//|                                                      a-SimpleTrailing.mqh  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  17.11.2005      .                  |
//|        :                                 |
//|    -    : #include <a-SimpleTrailing.mqh>                    |
//|                         color clModifyBuy  = Aqua;                         |
//|                         color clModifySell = Tomato;                       |
//|                         extern bool   UseSound        = True;              |
//|                         extern string NameFileSound   = "expert.wav";      |
//|                         extern int    NumberOfTry     = 3;                 |
//|                         extern int    PauseAfterError = 75;                |
//|    -   start(): if (UseTrailing) TrailingPositions();              |
//+----------------------------------------------------------------------------+
//-------    --------------------------------------------+
extern string _P_Trailing = "----------  ";
extern bool UseTrailing      = True;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStopBuy  = 50;          //   
extern int  TrailingStopSell = 50;          //   
extern int  TrailingStep     = 5;           //  
//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sym -    ("" -  )                   |
//|    op  -                   (-1 -  )                    |
//|    mn  - MagicNumber               (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sym = "", int op = -1, int mn = -1) 
  {
   double p, pp;
   int    i, k = OrdersTotal();
//----
   if(sym == "") 
       sym = Symbol();
   p = MarketInfo(sym, MODE_POINT);
   for(i = 0; i < k; i++) 
     {
       if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
         {
           if(OrderSymbol() == sym && (op < 0 || OrderType() == op)) 
             {
               if(mn < 0 || OrderMagicNumber() == mn) 
                 {
                   if(OrderType() == OP_BUY) 
                     {
                       pp = MarketInfo(sym, MODE_BID);
                       if(!ProfitTrailing || (pp - OrderOpenPrice()) > TrailingStopBuy*p) 
                         {
                           if(OrderStopLoss() < pp - (TrailingStopBuy + TrailingStep - 1)*p) 
                             {
                               ModifyOrder(-1, pp - TrailingStopBuy*p, 0, clModifyBuy);
                             }
                         }
                     }
                   if(OrderType() == OP_SELL) 
                     {
                       pp = MarketInfo(sym, MODE_ASK);
                       if(!ProfitTrailing || OrderOpenPrice() - pp > TrailingStopSell*p) 
                         {
                           if(OrderStopLoss() > pp + (TrailingStopSell + 
                              TrailingStep - 1)*p || OrderStopLoss() == 0) 
                             {
                               ModifyOrder(-1, pp + TrailingStopSell*p, 0, clModifySell);
                             }
                         }
                     }
                 }
             }
         }
     }
  }
//+----------------------------------------------------------------------------+
//|                                                           |
//|  :                                                                |
//|    pp -                                                                |
//|    sl -                                                                |
//|    tp -                                                                |
//|    cl -                                                                |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp = -1, double sl = 0, double tp = 0, color cl = CLR_NONE) 
  {
   bool fm;
   int  err, it;
//----
   if(pp <= 0) 
       pp = OrderOpenPrice();
   if(sl < 0) 
       sl = OrderStopLoss();
   if(tp < 0) 
       tp = OrderTakeProfit();
//---- 
   pp = NormalizeDouble(pp, Digits);
   sl = NormalizeDouble(sl, Digits);
   tp = NormalizeDouble(tp, Digits);
//----
   if(pp != OrderOpenPrice() || sl != OrderStopLoss() || tp != OrderTakeProfit()) 
     {
       for(it = 1; it <= NumberOfTry; it++) 
         {
           while(!IsTradeAllowed()) 
               Sleep(5000);
           RefreshRates();
           fm = OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
           if(fm) 
             {
               if(UseSound) 
                   PlaySound(NameFileSound); 
               break;
             } 
           else 
             {
               err = GetLastError();
               Print("Error(", err, ") modifying Order: ", ErrorDescription(err),
                     ", try ", it);
               Print("Ask=", Ask, "  Bid=", Bid, "  op=" + GetNameOP(OrderType()), 
                     "  pp=", pp, "  sl=", sl, "  tp=", tp);
               Sleep(1000*PauseAfterError);
             }
         }
     }
  }
//+----------------------------------------------------------------------------+

